var $ = window.$; // use the global jQuery instance

// var $uploadList     = $(".file-upload-list");  quitado
// var $uploadProgress = $("#file-upload-progress");
// var $barProgress    = $(".barProgress");
// var $textProgress   = $("#textProgress");

var $id_subtask     = $("#subtask_id").val();
var $id_task        = $("#task_id").val();

// delivered_active


     if (($("#jsonIdAttachments_task").length > 0)&&($("#jsonIdAttachments_task").val()!="")) {  

        jsonObj_task = JSON.parse($("#jsonIdAttachments_task").val());
    //  $("#jsonIdAttachments_task").val("");  quiza deba quitarse en ambos

    }else {

        jsonObj_task = [];

    }





 if (($("#jsonIdAttachments_subtask").length > 0)&&($("#jsonIdAttachments_subtask").val()!="")) {  

    jsonObj_subtask = JSON.parse($("#jsonIdAttachments_subtask").val());
    $("#jsonIdAttachments_subtask").val("");

}else {

    jsonObj_subtask = [];

}


//    if ( $("#undiv").length > 0 ) {



// console.log(jsonObj_subtask);

var string;

delivered_active = ( $(".delivered_active").length > 0 )?"desde subtask":null;

// console.log($(this).data("type"));
    

// if ($uploadList.length > 0) {  quitado 

    var id =  '';
    var idSequence = 0;

    $('.fileupload').fileupload({
        maxChunkSize: 1000000,
        method: "POST",
        sequentialUploads: true,

        formData: function (form) {

            $(".text_borrador").hide();  //  subtask task

        //    $(".attach_borrador").hide();

            $is_subtask     = ($(this)[0].fileInput.data("type")=="subtask")?"true":"false";    

            return [{name: '_token', value: $('input[name=_token]').val()},{name:"id",value:id},{name:"is_subtask",value:$is_subtask},{name:"id_subtask",value:$id_subtask},{name:"id_task",value:$id_task}];

        },

        progressall: function (e, data) {

            tecnolo = ($is_subtask !="true")?"task":"subtask";

            $("."+tecnolo+"_temporal_progress").show(); //   nuevo

//          $(".attach_borrador").hide();

        
//          console.log($(this).data("type"));

    //      console.log($(this));


            $uploadProgress = $("#file-upload-progress_"+$(this).data("type"));
            $barProgress    = $(".barProgress_"+$(this).data("type"));
            $textProgress   = $("#textProgress_"+$(this).data("type"));


            var progress = parseInt(data.loaded / data.total * 100, 10);
            //$("#"+data.theId).text('Subiendo '+progress + '%');
            $uploadProgress.text('Subiendo '+progress + '%');
            $barProgress.css('display','inline-block');
            $barProgress.val(progress);
            $textProgress.innerHTML = progress+'%';

    
            if(progress == 100){


                setTimeout(function(){ 

                            tecnolo = ($is_subtask !="true")?"task":"subtask";
                        //  console.log(tecnolo,$is_subtask);

                            $("."+tecnolo+"_temporal_progress").slideUp(300);   
                            $("."+$(this).data("type")+"_element >subattachtask_element:last").css("margin-bottom","4px");  
                            $("."+$(this).data("type")+"_element >subattachtask_element:first").css("margin-top","2px");  

                            // $("."+$(this).data("type")+"_element >.subattachtask_element:last")

                            }, 1500); //  nuevooo 

            }   

        },

        add: function (e, data) {
            // console.log(data);
            data._progress.theId = 'id_'+idSequence;
            idSequence++;
            //$uploadList.append($('<li id="'+data.theId+'"></li>').text('Subiendo'));
            //$uploadProgress.append($('<li id="'+data.theId+'"></li>').text('Subiendo'));
            data.submit();

        },
        done: function (e, data) {


            // console.log("dccccccccccccc"+$(this).data("type"));


            // $(".barProgress_task").css("margin-botton","6px");


            $uploadList  = $(".file-upload-list_"+$(this).data("type")); 

            //   console.log($uploadList.parent().parent());

            dumme = ($(this).data("type")=="subtask")?"sub":""; // suboption_subattachtask_   

            del = "";

            if(delivered_active){


                if ((!(typeof isteamleaderUnit === "undefined"))&&(isteamleaderUnit=="1")) {

                    del = "<button title='Entregar archivo a la tarea' type='button' onclick='deliverAttach("+data.result.id+")' class='not_deliver btn btn-xs stack_newed elementTheTask deliver_"+data.result.id+"' title='Entregar a la tarea'>e</button><i style='display:none' title='Archivo entregado a la tarea' class='fa fa-arrow-up delivered stack_newed elementTheTask nowdeliver_"+data.result.id+"' aria-hidden='true'></i>";
                
                }

            }

                

            if ((!(typeof noMostrarDelete === "undefined"))&&(noMostrarDelete=="1")) {

                delbtn = "";

            }else{

                attaasi = '"'+data.result.name+'"';

                delbtn = "<button type='button' onclick='"+dumme+"deleteAttach("+data.result.id+",false,"+attaasi+")' class='btn btn-danger btn-xs stack_deleted elementTheTask'>x</button>";

            }

            item_created = '<div data-fileatta="'+data.result.filename+'" data-dateatta="'+data.result.created_at+'" data-nameatta="'+data.result.name+'" class="bdn subattachtask_element '+dumme+'option_subattachtask_'+data.result.id+' subattachtask_'+data.result.id+'"><a href="'+url_tofs+'/download/'+data.result.id+'" target="_blank" style="font-size:11px">'+data.result.name+'<span class="minidatetask_'+data.result.id+'" style="margin-left: 6px;font-size: 11px;font-style: inherit;">'+data.result.created_at+'</span></a>'+delbtn+del+'</div>';

            // $uploadList.parent().append(item_created);  // agregao el texto del nuevo agregador

            $(".subattachtask_element:last").css("margin-bottom","0px");  


            // console.log("___"+delivered_active);


              //              console.log(item_created);
              //  console.log($(this).data("type"));


            if($("."+$(this).data("type")+"_element >.subattachtask_element").length > 0){


                //console.log("nunca entro");

                $("."+$(this).data("type")+"_element >.subattachtask_element:last").after(item_created);   //  $("."+$(this).data("type")+">.text_borrador")

            }else{


                //  temporal_progress
                //  $(".temporal_progress").before(item_created);

              // console.log("tigerrr",$(this).data("type"));

                $("."+$(this).data("type")+"_text_borrador").before(item_created);  //   cuando no existe ningun archivo   ver en subtarea 
                $("."+$(this).data("type")+"_text_borrador").hide();

            }



          
            // $uploadList.parent().prev().append(item_created);  task_element

            // $uploadList.append($('<li></li>').text('Subido: ' + data.result.name));

            item_task    = {};
            item_subtask = {};

//          item = {};
//          console.log(data.result.id);

            if($(this).data("type") == "task"){

                item_task["id"] = data.result.id;
                jsonObj_task.push(item_task);
                string = JSON.stringify(jsonObj_task)

            }

            if($(this).data("type")== "subtask"){

                item_subtask["id"] = data.result.id;
                jsonObj_subtask.push(item_subtask);
                string = JSON.stringify(jsonObj_subtask)

             //   console.log(string);
                
            }

            //  Muestro el boton de descarga

            seeDownload();

            $(".barProgress_"+$(this).data("type")).css("display","inline-block");

            $('#jsonIdAttachments_'+$(this).data("type")).val(string);

        },


    });



    function seeDownload(){



        //    $(".attach_borrador").hide();
            $(".nuevo_div").css("text-align","center");
            $("#buttonDownload").parent().css("margin-right","50px");


            if ( $(".attach_borrador").length == 0 ) {
               $("#buttonDownload").parent().css("margin-left","-70px");
            }

                               
            $(".box_elegirArchivo").css("float","left");
            $(".box_elegirArchivo").css("margin-right","8px");
            $(".box_elegirArchivo").css("margin-left","6px");
            $(".box_elegirArchivo").css("position","absolute");

            $(".box_supArchivo").css("margin-top","12px");
            $(".box_supArchivo").css("margin-bottom","12px");

            $(".box_supArchivo").css("display","block");
            
            $(".box_elegirArchivo").css("visibility","visible");
            $("#buttonDownload").show();

           // console.log("lalal");
            
          //  $(".box_supArchivo").css("display","grid");
            $(".box_supArchivo").css("text-align","center");
    
    }


